//=============================================================================
//
// file :        MIO.h
//
// description : Include for the MIO class.
//
// project :	MIO
//
// $Author: pascal_verdier $
//
// $Revision: 13293 $
// $Date: 2009-04-07 12:53:56 +0200 (Tue, 07 Apr 2009) $
//
// SVN only:
// $HeadURL: $
//
// CVS only:
// $Source$
// $Log$
// Revision 3.5  2007/10/23 14:04:30  pascal_verdier
// Spelling mistakes correction
//
// Revision 3.4  2005/03/02 14:06:15  pascal_verdier
// namespace is different than class name.
//
// Revision 3.3  2004/10/25 14:12:00  pascal_verdier
// Minor changes.
//
// Revision 3.2  2004/09/06 09:27:05  pascal_verdier
// Modified for Tango 5 compatibility.
//
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043
//               FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _MIO_H
#define _MIO_H

#include <tango.h>
#include <mio.h>

//using namespace Tango;

/**
 * @author	$Author: pascal_verdier $
 * @version	$Revision: 13293 $
 */

 //	Add your own constant definitions here.
 //-----------------------------------------------


namespace MIO_ns
{

/**
 * Class Description:
 * Device Server for Multi I/O board
 */

/*
 *	Device States Description:
*  Tango::DISABLE :  Cannot attach driver
*  Tango::ON :       working correctly
*  Tango::FAULT :    last ioctl returned an error
 */


class MIO: public TANGO_BASE_CLASS
{
public :
	//	Add your own data members here
	//-----------------------------------------


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attribute member data.
 */
//@{
		Tango::DevLong	*attr_Freq_chan0_read;
		Tango::DevLong	attr_Freq_chan0_write;
		Tango::DevLong	*attr_Freq_chan1_read;
		Tango::DevLong	attr_Freq_chan1_write;
		Tango::DevLong	*attr_Freq_chan2_read;
		Tango::DevLong	attr_Freq_chan2_write;
		Tango::DevLong	*attr_Freq_chan3_read;
		Tango::DevLong	attr_Freq_chan3_write;
		Tango::DevLong	*attr_Freq_chan4_read;
		Tango::DevLong	attr_Freq_chan4_write;
		Tango::DevLong	*attr_Freq_chan5_read;
		Tango::DevLong	attr_Freq_chan5_write;
		Tango::DevLong	*attr_Freq_chan6_read;
		Tango::DevLong	attr_Freq_chan6_write;
		Tango::DevLong	*attr_Freq_chan7_read;
		Tango::DevLong	attr_Freq_chan7_write;
		Tango::DevLong	*attr_Freq_chan8_read;
		Tango::DevLong	attr_Freq_chan8_write;
		Tango::DevLong	*attr_Freq_chan9_read;
		Tango::DevLong	attr_Freq_chan9_write;
		Tango::DevLong	*attr_Freq_chan10_read;
		Tango::DevLong	attr_Freq_chan10_write;
		Tango::DevLong	*attr_Freq_chan11_read;
		Tango::DevLong	attr_Freq_chan11_write;
		Tango::DevLong	*attr_Freq_chan12_read;
		Tango::DevLong	attr_Freq_chan12_write;
		Tango::DevLong	*attr_Freq_chan13_read;
		Tango::DevLong	attr_Freq_chan13_write;
		Tango::DevLong	*attr_Freq_chan14_read;
		Tango::DevLong	attr_Freq_chan14_write;
		Tango::DevLong	*attr_Freq_chan15_read;
		Tango::DevLong	attr_Freq_chan15_write;
//@}

/**
 * @name Device properties
 * Device properties member data.
 */
//@{
/**
 *	Multi I/O board identifier
 */
	string	mio_name;
/**
 *	configurations of all channels
 *	0 = DI
 *	1 = FI
 *	2 = DO
 *	3 = FO
 */
	vector<short>	chan_confs;
/**
 *	Timeout for trigger presence check (using interrupt) [ms]
 */
	Tango::DevShort	irq_tout;
/**
 *	1 = enable
 *	0 = disable
 */
	Tango::DevBoolean	irq_enab;
//@}

/**
 *	@name Device properties
 *	Device property member data.
 */
//@{
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	MIO(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	MIO(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	MIO(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one destructor is defined for this class */
//@{
/**
 * The object destructor.
 */	
	~MIO() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method before execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name MIO methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for Freq_chan0 acquisition result.
 */
	virtual void read_Freq_chan0(Tango::Attribute &attr);
/**
 *	Write Freq_chan0 attribute values to hardware.
 */
	virtual void write_Freq_chan0(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Freq_chan1 acquisition result.
 */
	virtual void read_Freq_chan1(Tango::Attribute &attr);
/**
 *	Write Freq_chan1 attribute values to hardware.
 */
	virtual void write_Freq_chan1(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Freq_chan2 acquisition result.
 */
	virtual void read_Freq_chan2(Tango::Attribute &attr);
/**
 *	Write Freq_chan2 attribute values to hardware.
 */
	virtual void write_Freq_chan2(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Freq_chan3 acquisition result.
 */
	virtual void read_Freq_chan3(Tango::Attribute &attr);
/**
 *	Write Freq_chan3 attribute values to hardware.
 */
	virtual void write_Freq_chan3(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Freq_chan4 acquisition result.
 */
	virtual void read_Freq_chan4(Tango::Attribute &attr);
/**
 *	Write Freq_chan4 attribute values to hardware.
 */
	virtual void write_Freq_chan4(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Freq_chan5 acquisition result.
 */
	virtual void read_Freq_chan5(Tango::Attribute &attr);
/**
 *	Write Freq_chan5 attribute values to hardware.
 */
	virtual void write_Freq_chan5(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Freq_chan6 acquisition result.
 */
	virtual void read_Freq_chan6(Tango::Attribute &attr);
/**
 *	Write Freq_chan6 attribute values to hardware.
 */
	virtual void write_Freq_chan6(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Freq_chan7 acquisition result.
 */
	virtual void read_Freq_chan7(Tango::Attribute &attr);
/**
 *	Write Freq_chan7 attribute values to hardware.
 */
	virtual void write_Freq_chan7(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Freq_chan8 acquisition result.
 */
	virtual void read_Freq_chan8(Tango::Attribute &attr);
/**
 *	Write Freq_chan8 attribute values to hardware.
 */
	virtual void write_Freq_chan8(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Freq_chan9 acquisition result.
 */
	virtual void read_Freq_chan9(Tango::Attribute &attr);
/**
 *	Write Freq_chan9 attribute values to hardware.
 */
	virtual void write_Freq_chan9(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Freq_chan10 acquisition result.
 */
	virtual void read_Freq_chan10(Tango::Attribute &attr);
/**
 *	Write Freq_chan10 attribute values to hardware.
 */
	virtual void write_Freq_chan10(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Freq_chan11 acquisition result.
 */
	virtual void read_Freq_chan11(Tango::Attribute &attr);
/**
 *	Write Freq_chan11 attribute values to hardware.
 */
	virtual void write_Freq_chan11(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Freq_chan12 acquisition result.
 */
	virtual void read_Freq_chan12(Tango::Attribute &attr);
/**
 *	Write Freq_chan12 attribute values to hardware.
 */
	virtual void write_Freq_chan12(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Freq_chan13 acquisition result.
 */
	virtual void read_Freq_chan13(Tango::Attribute &attr);
/**
 *	Write Freq_chan13 attribute values to hardware.
 */
	virtual void write_Freq_chan13(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Freq_chan14 acquisition result.
 */
	virtual void read_Freq_chan14(Tango::Attribute &attr);
/**
 *	Write Freq_chan14 attribute values to hardware.
 */
	virtual void write_Freq_chan14(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Freq_chan15 acquisition result.
 */
	virtual void read_Freq_chan15(Tango::Attribute &attr);
/**
 *	Write Freq_chan15 attribute values to hardware.
 */
	virtual void write_Freq_chan15(Tango::WAttribute &attr);
/**
 *	Read/Write allowed for Freq_chan0 attribute.
 */
	virtual bool is_Freq_chan0_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Freq_chan1 attribute.
 */
	virtual bool is_Freq_chan1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Freq_chan2 attribute.
 */
	virtual bool is_Freq_chan2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Freq_chan3 attribute.
 */
	virtual bool is_Freq_chan3_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Freq_chan4 attribute.
 */
	virtual bool is_Freq_chan4_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Freq_chan5 attribute.
 */
	virtual bool is_Freq_chan5_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Freq_chan6 attribute.
 */
	virtual bool is_Freq_chan6_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Freq_chan7 attribute.
 */
	virtual bool is_Freq_chan7_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Freq_chan8 attribute.
 */
	virtual bool is_Freq_chan8_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Freq_chan9 attribute.
 */
	virtual bool is_Freq_chan9_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Freq_chan10 attribute.
 */
	virtual bool is_Freq_chan10_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Freq_chan11 attribute.
 */
	virtual bool is_Freq_chan11_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Freq_chan12 attribute.
 */
	virtual bool is_Freq_chan12_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Freq_chan13 attribute.
 */
	virtual bool is_Freq_chan13_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Freq_chan14 attribute.
 */
	virtual bool is_Freq_chan14_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Freq_chan15 attribute.
 */
	virtual bool is_Freq_chan15_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for write_digit command.
 */
	virtual bool is_write_digit_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for write_freq command.
 */
	virtual bool is_write_freq_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for write_conf command.
 */
	virtual bool is_write_conf_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for write_irqtoutena command.
 */
	virtual bool is_write_irqtoutena_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for write_irqtout command.
 */
	virtual bool is_write_irqtout_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for write_pulse command.
 */
	virtual bool is_write_pulse_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for read_digit command.
 */
	virtual bool is_read_digit_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for read_digits command.
 */
	virtual bool is_read_digits_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for read_freq command.
 */
	virtual bool is_read_freq_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for read_conf command.
 */
	virtual bool is_read_conf_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for read_digitset command.
 */
	virtual bool is_read_digitset_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for read_digitsets command.
 */
	virtual bool is_read_digitsets_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for read_freqset command.
 */
	virtual bool is_read_freqset_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for read_irqtoutstat command.
 */
	virtual bool is_read_irqtoutstat_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for read_irqtout command.
 */
	virtual bool is_read_irqtout_allowed(const CORBA::Any &any);
/**
 * write to a digital channel
 *	chan = [0-15]
 *	value = [0|1]
 *	@param	argin	args0=chan args1=value
 *	@exception DevFailed
 */
	void	write_digit(const Tango::DevVarUShortArray *);
/**
 * write frequency output
 *	@param	argin	args0=chan args1=value
 *	@exception DevFailed
 */
	void	write_freq(const Tango::DevVarUShortArray *);
/**
 * Write configuration
 *	chan = [0-15]
 *	value:
 *	0 = DI
 *	1 = FI
 *	2 = DO
 *	3 = FO
 *	@param	argin	args0=chan args1=value
 *	@exception DevFailed
 */
	void	write_conf(const Tango::DevVarUShortArray *);
/**
 * enable timeout check on interrupt (validate data only if trigger has come recently
 *	@param	argin	args1=value
 *	@exception DevFailed
 */
	void	write_irqtoutena(Tango::DevUShort);
/**
 * set timeout [s] for check of trigger presence
 *	@param	argin	timeout [s]
 *	@exception DevFailed
 */
	void	write_irqtout(Tango::DevUShort);
/**
 * write a pulse
 *	@param	argin	args0=chan 
 *	@exception DevFailed
 */
	void	write_pulse(Tango::DevUShort);
/**
 * read a digital channel
 *	@param	argin	chan
 *	@return	value
 *	@exception DevFailed
 */
	Tango::DevUShort	read_digit(Tango::DevUShort);
/**
 * read all digital channels
 *	@return	values
 *	@exception DevFailed
 */
	Tango::DevUShort	read_digits();
/**
 * read frequency value
 *	@param	argin	chan
 *	@return	value
 *	@exception DevFailed
 */
	Tango::DevUShort	read_freq(Tango::DevUShort);
/**
 * read configuration
 *	chan = [0-15]
 *	value:
 *	0 = DI
 *	1 = FI
 *	2 = DO
 *	3 = FO
 *	@param	argin	chan
 *	@return	value
 *	@exception DevFailed
 */
	Tango::DevUShort	read_conf(Tango::DevUShort);
/**
 * read digital output
 *	@param	argin	chan
 *	@return	value
 *	@exception DevFailed
 */
	Tango::DevUShort	read_digitset(Tango::DevUShort);
/**
 * read all digital outputs
 *	@return	value
 *	@exception DevFailed
 */
	Tango::DevUShort	read_digitsets();
/**
 * read output frequency
 *	@param	argin	chan
 *	@return	value
 *	@exception DevFailed
 */
	Tango::DevUShort	read_freqset(Tango::DevUShort);
/**
 * read trigger timeout
 *	@return	
 *	@exception DevFailed
 */
	Tango::DevUShort	read_irqtoutstat();
/**
 * read trigger timeout
 *	@return	timeout
 *	@exception DevFailed
 */
	Tango::DevUShort	read_irqtout();

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	



protected :	
	//	Add your own data members here
	//-----------------------------------------
	int mio_dev;
	char rsn[25];  // Exception reason	
	void timestamp();
	
	void write_chan_frequency(int32_t chan, int32_t val);
	int32_t read_chan_set_frequency(int32_t chan);	
	
};

}	// namespace_ns

#endif	// _MIO_H
