static const char *ClassId    = "$Id: DevServClass.cpp 13293 2009-04-07 10:53:56Z pascal_verdier $";
static const char *TagName    = "$Name$";
static const char *CvsPath    = "$Source$";
static const char *SvnPath    = "$HeadURL: $";
static const char *HttpServer = "http://www.esrf.fr/computing/cs/tango/tango_doc/ds_doc/";
//+=============================================================================
//
// file :        MIOClass.cpp
//
// description : C++ source for the MIOClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the MIO once per process.
//
// project :     TANGO Device Server
//
// $Author: pascal_verdier $
//
// $Revision: 13293 $
//
// $Log$
// Revision 3.11  2007/10/23 14:04:30  pascal_verdier
// Spelling mistakes correction
//
// Revision 3.10  2006/11/15 14:17:10  pascal_verdier
// Remove warnings from compiler.
//
// Revision 3.9  2006/06/26 09:31:03  pascal_verdier
// Tango-5.5 compatiblity.
// extern C method added to be used as shared library.
// VCC 6 project file generated if running on Win32.
// .obj, .so, executable files generated in separated directories.
//
// Revision 3.8  2005/09/08 08:45:23  pascal_verdier
// For Pogo-4.4.0 and above.
//
// Revision 3.7  2005/06/17 08:53:21  pascal_verdier
// CVS tags management added.
//
// Revision 3.6  2005/05/19 13:11:18  pascal_verdier
// *** empty log message ***
//
// Revision 3.5  2005/03/02 14:06:15  pascal_verdier
// namespace is different than class name.
//
// Revision 3.4  2004/12/10 13:23:27  pascal_verdier
// Pogo-4.0.0 (Ready for Tango5).
//
// Revision 3.3  2004/11/08 14:27:21  pascal_verdier
// *** empty log message ***
//
// Revision 3.2  2004/11/08 11:33:16  pascal_verdier
// if device property not found in database, it takes class property value if exists.
//
// Revision 3.1  2004/09/06 09:27:05  pascal_verdier
// Modified for Tango 5 compatibility.
//
//
// copyleft :   European Synchrotron Radiation Facility
//              BP 220, Grenoble 38043
//              FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <MIO.h>
#include <MIOClass.h>


//+----------------------------------------------------------------------------
/**
 *	Create MIOClass singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_MIO_class(const char *name) {
		return MIO_ns::MIOClass::init(name);
	}
}


namespace MIO_ns
{

//+----------------------------------------------------------------------------
//
// method : 		write_digitClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *write_digitClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "write_digitClass::execute(): arrived" << endl;

	const Tango::DevVarUShortArray	*argin;
	extract(in_any, argin);

	((static_cast<MIO *>(device))->write_digit(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		write_freqClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *write_freqClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "write_freqClass::execute(): arrived" << endl;

	const Tango::DevVarUShortArray	*argin;
	extract(in_any, argin);

	((static_cast<MIO *>(device))->write_freq(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		write_confClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *write_confClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "write_confClass::execute(): arrived" << endl;

	const Tango::DevVarUShortArray	*argin;
	extract(in_any, argin);

	((static_cast<MIO *>(device))->write_conf(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		write_irqtoutenaClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *write_irqtoutenaClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "write_irqtoutenaClass::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);

	((static_cast<MIO *>(device))->write_irqtoutena(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		write_irqtoutClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *write_irqtoutClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "write_irqtoutClass::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);

	((static_cast<MIO *>(device))->write_irqtout(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		write_pulseClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *write_pulseClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "write_pulseClass::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);

	((static_cast<MIO *>(device))->write_pulse(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		read_digitClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *read_digitClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "read_digitClass::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);

	return insert((static_cast<MIO *>(device))->read_digit(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		read_digitsClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *read_digitsClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "read_digitsClass::execute(): arrived" << endl;

	return insert((static_cast<MIO *>(device))->read_digits());
}

//+----------------------------------------------------------------------------
//
// method : 		read_freqClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *read_freqClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "read_freqClass::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);

	return insert((static_cast<MIO *>(device))->read_freq(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		read_confClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *read_confClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "read_confClass::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);

	return insert((static_cast<MIO *>(device))->read_conf(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		read_digitsetClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *read_digitsetClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "read_digitsetClass::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);

	return insert((static_cast<MIO *>(device))->read_digitset(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		read_digitsetsClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *read_digitsetsClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "read_digitsetsClass::execute(): arrived" << endl;

	return insert((static_cast<MIO *>(device))->read_digitsets());
}

//+----------------------------------------------------------------------------
//
// method : 		read_freqsetClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *read_freqsetClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "read_freqsetClass::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);

	return insert((static_cast<MIO *>(device))->read_freqset(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		read_irqtoutstatClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *read_irqtoutstatClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "read_irqtoutstatClass::execute(): arrived" << endl;

	return insert((static_cast<MIO *>(device))->read_irqtoutstat());
}

//+----------------------------------------------------------------------------
//
// method : 		read_irqtoutClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be executed
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *read_irqtoutClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "read_irqtoutClass::execute(): arrived" << endl;

	return insert((static_cast<MIO *>(device))->read_irqtout());
}


//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
MIOClass *MIOClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		MIOClass::MIOClass(string &s)
// 
// description : 	constructor for the MIOClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
MIOClass::MIOClass(string &s):DeviceClass(s)
{

	cout2 << "Entering MIOClass constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();
	
	cout2 << "Leaving MIOClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		MIOClass::~MIOClass()
// 
// description : 	destructor for the MIOClass
//
//-----------------------------------------------------------------------------
MIOClass::~MIOClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		MIOClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
MIOClass *MIOClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new MIOClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

MIOClass *MIOClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		MIOClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void MIOClass::command_factory()
{
	command_list.push_back(new write_digitClass("write_digit",
		Tango::DEVVAR_USHORTARRAY, Tango::DEV_VOID,
		"args0=chan args1=value",
		"",
		Tango::OPERATOR));
	command_list.push_back(new write_freqClass("write_freq",
		Tango::DEVVAR_USHORTARRAY, Tango::DEV_VOID,
		"args0=chan args1=value",
		"",
		Tango::OPERATOR));
	command_list.push_back(new write_confClass("write_conf",
		Tango::DEVVAR_USHORTARRAY, Tango::DEV_VOID,
		"args0=chan args1=value",
		"",
		Tango::OPERATOR));
	command_list.push_back(new write_irqtoutenaClass("write_irqtoutena",
		Tango::DEV_USHORT, Tango::DEV_VOID,
		"args1=value",
		"",
		Tango::OPERATOR));
	command_list.push_back(new write_irqtoutClass("write_irqtout",
		Tango::DEV_USHORT, Tango::DEV_VOID,
		"timeout [s]",
		"",
		Tango::OPERATOR));
	command_list.push_back(new write_pulseClass("write_pulse",
		Tango::DEV_USHORT, Tango::DEV_VOID,
		"args0=chan ",
		"",
		Tango::OPERATOR));
	command_list.push_back(new read_digitClass("read_digit",
		Tango::DEV_USHORT, Tango::DEV_USHORT,
		"chan",
		"value",
		Tango::OPERATOR));
	command_list.push_back(new read_digitsClass("read_digits",
		Tango::DEV_VOID, Tango::DEV_USHORT,
		"",
		"values",
		Tango::OPERATOR));
	command_list.push_back(new read_freqClass("read_freq",
		Tango::DEV_USHORT, Tango::DEV_USHORT,
		"chan",
		"value",
		Tango::OPERATOR));
	command_list.push_back(new read_confClass("read_conf",
		Tango::DEV_USHORT, Tango::DEV_USHORT,
		"chan",
		"value",
		Tango::OPERATOR));
	command_list.push_back(new read_digitsetClass("read_digitset",
		Tango::DEV_USHORT, Tango::DEV_USHORT,
		"chan",
		"value",
		Tango::OPERATOR));
	command_list.push_back(new read_digitsetsClass("read_digitsets",
		Tango::DEV_VOID, Tango::DEV_USHORT,
		"",
		"value",
		Tango::OPERATOR));
	command_list.push_back(new read_freqsetClass("read_freqset",
		Tango::DEV_USHORT, Tango::DEV_USHORT,
		"chan",
		"value",
		Tango::OPERATOR));
	command_list.push_back(new read_irqtoutstatClass("read_irqtoutstat",
		Tango::DEV_VOID, Tango::DEV_USHORT,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new read_irqtoutClass("read_irqtout",
		Tango::DEV_VOID, Tango::DEV_USHORT,
		"",
		"timeout",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		MIOClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum MIOClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		MIOClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum MIOClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		MIOClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum MIOClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		MIOClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void MIOClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new MIO(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: MIOClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void MIOClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : Freq_chan0
	Freq_chan0Attrib	*freq_chan0 = new Freq_chan0Attrib();
	Tango::UserDefaultAttrProp	freq_chan0_prop;
	freq_chan0_prop.set_format("%d");
	freq_chan0_prop.set_max_value("65535");
	freq_chan0_prop.set_min_value("0");
	freq_chan0->set_default_properties(freq_chan0_prop);
	att_list.push_back(freq_chan0);

	//	Attribute : Freq_chan1
	Freq_chan1Attrib	*freq_chan1 = new Freq_chan1Attrib();
	Tango::UserDefaultAttrProp	freq_chan1_prop;
	freq_chan1_prop.set_format("%d");
	freq_chan1_prop.set_max_value("65535");
	freq_chan1_prop.set_min_value("0");
	freq_chan1->set_default_properties(freq_chan1_prop);
	att_list.push_back(freq_chan1);

	//	Attribute : Freq_chan2
	Freq_chan2Attrib	*freq_chan2 = new Freq_chan2Attrib();
	Tango::UserDefaultAttrProp	freq_chan2_prop;
	freq_chan2_prop.set_format("%d");
	freq_chan2_prop.set_max_value("65535");
	freq_chan2_prop.set_min_value("0");
	freq_chan2->set_default_properties(freq_chan2_prop);
	att_list.push_back(freq_chan2);

	//	Attribute : Freq_chan3
	Freq_chan3Attrib	*freq_chan3 = new Freq_chan3Attrib();
	Tango::UserDefaultAttrProp	freq_chan3_prop;
	freq_chan3_prop.set_format("%d");
	freq_chan3_prop.set_max_value("65535");
	freq_chan3_prop.set_min_value("0");
	freq_chan3->set_default_properties(freq_chan3_prop);
	att_list.push_back(freq_chan3);

	//	Attribute : Freq_chan4
	Freq_chan4Attrib	*freq_chan4 = new Freq_chan4Attrib();
	Tango::UserDefaultAttrProp	freq_chan4_prop;
	freq_chan4_prop.set_format("%d");
	freq_chan4_prop.set_max_value("65535");
	freq_chan4_prop.set_min_value("0");
	freq_chan4->set_default_properties(freq_chan4_prop);
	att_list.push_back(freq_chan4);

	//	Attribute : Freq_chan5
	Freq_chan5Attrib	*freq_chan5 = new Freq_chan5Attrib();
	Tango::UserDefaultAttrProp	freq_chan5_prop;
	freq_chan5_prop.set_format("%d");
	freq_chan5_prop.set_max_value("65535");
	freq_chan5_prop.set_min_value("0");
	freq_chan5->set_default_properties(freq_chan5_prop);
	att_list.push_back(freq_chan5);

	//	Attribute : Freq_chan6
	Freq_chan6Attrib	*freq_chan6 = new Freq_chan6Attrib();
	Tango::UserDefaultAttrProp	freq_chan6_prop;
	freq_chan6_prop.set_format("%d");
	freq_chan6_prop.set_max_value("65535");
	freq_chan6_prop.set_min_value("0");
	freq_chan6->set_default_properties(freq_chan6_prop);
	att_list.push_back(freq_chan6);

	//	Attribute : Freq_chan7
	Freq_chan7Attrib	*freq_chan7 = new Freq_chan7Attrib();
	Tango::UserDefaultAttrProp	freq_chan7_prop;
	freq_chan7_prop.set_format("%d");
	freq_chan7_prop.set_max_value("65535");
	freq_chan7_prop.set_min_value("0");
	freq_chan7->set_default_properties(freq_chan7_prop);
	att_list.push_back(freq_chan7);

	//	Attribute : Freq_chan8
	Freq_chan8Attrib	*freq_chan8 = new Freq_chan8Attrib();
	Tango::UserDefaultAttrProp	freq_chan8_prop;
	freq_chan8_prop.set_format("%d");
	freq_chan8_prop.set_max_value("65535");
	freq_chan8_prop.set_min_value("0");
	freq_chan8->set_default_properties(freq_chan8_prop);
	att_list.push_back(freq_chan8);

	//	Attribute : Freq_chan9
	Freq_chan9Attrib	*freq_chan9 = new Freq_chan9Attrib();
	Tango::UserDefaultAttrProp	freq_chan9_prop;
	freq_chan9_prop.set_format("%d");
	freq_chan9_prop.set_max_value("65535");
	freq_chan9_prop.set_min_value("0");
	freq_chan9->set_default_properties(freq_chan9_prop);
	att_list.push_back(freq_chan9);

	//	Attribute : Freq_chan10
	Freq_chan10Attrib	*freq_chan10 = new Freq_chan10Attrib();
	Tango::UserDefaultAttrProp	freq_chan10_prop;
	freq_chan10_prop.set_format("%d");
	freq_chan10_prop.set_max_value("65535");
	freq_chan10_prop.set_min_value("0");
	freq_chan10->set_default_properties(freq_chan10_prop);
	att_list.push_back(freq_chan10);

	//	Attribute : Freq_chan11
	Freq_chan11Attrib	*freq_chan11 = new Freq_chan11Attrib();
	Tango::UserDefaultAttrProp	freq_chan11_prop;
	freq_chan11_prop.set_format("%d");
	freq_chan11_prop.set_max_value("65535");
	freq_chan11_prop.set_min_value("0");
	freq_chan11->set_default_properties(freq_chan11_prop);
	att_list.push_back(freq_chan11);

	//	Attribute : Freq_chan12
	Freq_chan12Attrib	*freq_chan12 = new Freq_chan12Attrib();
	Tango::UserDefaultAttrProp	freq_chan12_prop;
	freq_chan12_prop.set_format("%d");
	freq_chan12_prop.set_max_value("65535");
	freq_chan12_prop.set_min_value("0");
	freq_chan12->set_default_properties(freq_chan12_prop);
	att_list.push_back(freq_chan12);

	//	Attribute : Freq_chan13
	Freq_chan13Attrib	*freq_chan13 = new Freq_chan13Attrib();
	Tango::UserDefaultAttrProp	freq_chan13_prop;
	freq_chan13_prop.set_format("%d");
	freq_chan13_prop.set_max_value("65535");
	freq_chan13_prop.set_min_value("0");
	freq_chan13->set_default_properties(freq_chan13_prop);
	att_list.push_back(freq_chan13);

	//	Attribute : Freq_chan14
	Freq_chan14Attrib	*freq_chan14 = new Freq_chan14Attrib();
	Tango::UserDefaultAttrProp	freq_chan14_prop;
	freq_chan14_prop.set_format("%d");
	freq_chan14_prop.set_max_value("65535");
	freq_chan14_prop.set_min_value("0");
	freq_chan14->set_default_properties(freq_chan14_prop);
	att_list.push_back(freq_chan14);

	//	Attribute : Freq_chan15
	Freq_chan15Attrib	*freq_chan15 = new Freq_chan15Attrib();
	Tango::UserDefaultAttrProp	freq_chan15_prop;
	freq_chan15_prop.set_format("%d");
	freq_chan15_prop.set_max_value("65535");
	freq_chan15_prop.set_min_value("0");
	freq_chan15->set_default_properties(freq_chan15_prop);
	att_list.push_back(freq_chan15);

	//	End of Automatic code generation
	//-------------------------------------------------------------
}

//+----------------------------------------------------------------------------
//
// method : 		MIOClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void MIOClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	MIOClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void MIOClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "Mio_name";
	prop_desc = "Multi I/O board identifier";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Chan_confs";
	prop_desc = "configurations of all channels\n0 = DI\n1 = FI\n2 = DO\n3 = FO";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Irq_tout";
	prop_desc = "Timeout for trigger presence check (using interrupt) [ms]";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Irq_enab";
	prop_desc = "1 = enable\n0 = disable";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		MIOClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void MIOClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("MIO");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Device Server for Multi I/O board");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs or svn location
	string	filename(classname);
	filename += "Class.cpp";
	
	// Create a string with the class ID to
	// get the string into the binary
	string	class_id(ClassId);
	
	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}
	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
