//=============================================================================
//
// file :         MIOClass.h
//
// description :  Include for the MIOClass root class.
//                This class is the singleton class for
//                the MIO device class.
//                It contains all properties and methods which the 
//                MIO requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: pascal_verdier $
//
// $Revision: 14110 $
// $Date: 2010-02-10 08:47:17 +0100 (Wed, 10 Feb 2010) $
//
// SVN only:
// $HeadURL: $
//
// CVS only:
// $Source$
// $Log$
// Revision 3.8  2009/04/07 10:53:56  pascal_verdier
// Tango-7 release.
// SVN tags added
//
// Revision 3.7  2008/04/07 12:01:57  pascal_verdier
// CVS put property modified.
//
// Revision 3.6  2007/10/23 14:04:30  pascal_verdier
// Spelling mistakes correction
//
// Revision 3.5  2007/09/14 14:36:08  pascal_verdier
// Add an ifdef WIN32 for dll generation
//
// Revision 3.4  2005/09/08 08:45:23  pascal_verdier
// For Pogo-4.4.0 and above.
//
// Revision 3.3  2005/03/02 14:06:15  pascal_verdier
// namespace is different than class name.
//
// Revision 3.2  2004/11/08 11:33:16  pascal_verdier
// if device property not found in database, it takes class property value if exists.
//
// Revision 3.1  2004/09/06 09:27:05  pascal_verdier
// Modified for Tango 5 compatibility.
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _MIOCLASS_H
#define _MIOCLASS_H

#include <tango.h>
#include <MIO.h>


namespace MIO_ns
{//=====================================
//	Define classes for attributes
//=====================================
class Freq_chan15Attrib: public Tango::Attr
{
public:
	Freq_chan15Attrib():Attr("Freq_chan15", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan15Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan15(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan15(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan15_allowed(ty);}
};

class Freq_chan14Attrib: public Tango::Attr
{
public:
	Freq_chan14Attrib():Attr("Freq_chan14", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan14Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan14(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan14(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan14_allowed(ty);}
};

class Freq_chan13Attrib: public Tango::Attr
{
public:
	Freq_chan13Attrib():Attr("Freq_chan13", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan13Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan13(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan13(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan13_allowed(ty);}
};

class Freq_chan12Attrib: public Tango::Attr
{
public:
	Freq_chan12Attrib():Attr("Freq_chan12", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan12Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan12(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan12(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan12_allowed(ty);}
};

class Freq_chan11Attrib: public Tango::Attr
{
public:
	Freq_chan11Attrib():Attr("Freq_chan11", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan11Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan11(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan11(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan11_allowed(ty);}
};

class Freq_chan10Attrib: public Tango::Attr
{
public:
	Freq_chan10Attrib():Attr("Freq_chan10", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan10Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan10(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan10(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan10_allowed(ty);}
};

class Freq_chan9Attrib: public Tango::Attr
{
public:
	Freq_chan9Attrib():Attr("Freq_chan9", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan9Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan9(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan9(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan9_allowed(ty);}
};

class Freq_chan8Attrib: public Tango::Attr
{
public:
	Freq_chan8Attrib():Attr("Freq_chan8", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan8Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan8(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan8(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan8_allowed(ty);}
};

class Freq_chan7Attrib: public Tango::Attr
{
public:
	Freq_chan7Attrib():Attr("Freq_chan7", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan7Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan7(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan7(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan7_allowed(ty);}
};

class Freq_chan6Attrib: public Tango::Attr
{
public:
	Freq_chan6Attrib():Attr("Freq_chan6", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan6Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan6(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan6(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan6_allowed(ty);}
};

class Freq_chan5Attrib: public Tango::Attr
{
public:
	Freq_chan5Attrib():Attr("Freq_chan5", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan5Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan5(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan5(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan5_allowed(ty);}
};

class Freq_chan4Attrib: public Tango::Attr
{
public:
	Freq_chan4Attrib():Attr("Freq_chan4", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan4Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan4(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan4(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan4_allowed(ty);}
};

class Freq_chan3Attrib: public Tango::Attr
{
public:
	Freq_chan3Attrib():Attr("Freq_chan3", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan3Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan3(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan3(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan3_allowed(ty);}
};

class Freq_chan2Attrib: public Tango::Attr
{
public:
	Freq_chan2Attrib():Attr("Freq_chan2", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan2(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan2_allowed(ty);}
};

class Freq_chan1Attrib: public Tango::Attr
{
public:
	Freq_chan1Attrib():Attr("Freq_chan1", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan1_allowed(ty);}
};

class Freq_chan0Attrib: public Tango::Attr
{
public:
	Freq_chan0Attrib():Attr("Freq_chan0", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Freq_chan0Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<MIO *>(dev))->read_Freq_chan0(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<MIO *>(dev))->write_Freq_chan0(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<MIO *>(dev))->is_Freq_chan0_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class read_irqtoutClass : public Tango::Command
{
public:
	read_irqtoutClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	read_irqtoutClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~read_irqtoutClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MIO *>(dev))->is_read_irqtout_allowed(any);}
};



class read_irqtoutstatClass : public Tango::Command
{
public:
	read_irqtoutstatClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	read_irqtoutstatClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~read_irqtoutstatClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MIO *>(dev))->is_read_irqtoutstat_allowed(any);}
};



class read_freqsetClass : public Tango::Command
{
public:
	read_freqsetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	read_freqsetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~read_freqsetClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MIO *>(dev))->is_read_freqset_allowed(any);}
};



class read_digitsetsClass : public Tango::Command
{
public:
	read_digitsetsClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	read_digitsetsClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~read_digitsetsClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MIO *>(dev))->is_read_digitsets_allowed(any);}
};



class read_digitsetClass : public Tango::Command
{
public:
	read_digitsetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	read_digitsetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~read_digitsetClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MIO *>(dev))->is_read_digitset_allowed(any);}
};



class read_confClass : public Tango::Command
{
public:
	read_confClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	read_confClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~read_confClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MIO *>(dev))->is_read_conf_allowed(any);}
};



class read_freqClass : public Tango::Command
{
public:
	read_freqClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	read_freqClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~read_freqClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MIO *>(dev))->is_read_freq_allowed(any);}
};



class read_digitsClass : public Tango::Command
{
public:
	read_digitsClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	read_digitsClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~read_digitsClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MIO *>(dev))->is_read_digits_allowed(any);}
};



class read_digitClass : public Tango::Command
{
public:
	read_digitClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	read_digitClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~read_digitClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MIO *>(dev))->is_read_digit_allowed(any);}
};



class write_pulseClass : public Tango::Command
{
public:
	write_pulseClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	write_pulseClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~write_pulseClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MIO *>(dev))->is_write_pulse_allowed(any);}
};



class write_irqtoutClass : public Tango::Command
{
public:
	write_irqtoutClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	write_irqtoutClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~write_irqtoutClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MIO *>(dev))->is_write_irqtout_allowed(any);}
};



class write_irqtoutenaClass : public Tango::Command
{
public:
	write_irqtoutenaClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	write_irqtoutenaClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~write_irqtoutenaClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MIO *>(dev))->is_write_irqtoutena_allowed(any);}
};



class write_confClass : public Tango::Command
{
public:
	write_confClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	write_confClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~write_confClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MIO *>(dev))->is_write_conf_allowed(any);}
};



class write_freqClass : public Tango::Command
{
public:
	write_freqClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	write_freqClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~write_freqClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MIO *>(dev))->is_write_freq_allowed(any);}
};



class write_digitClass : public Tango::Command
{
public:
	write_digitClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	write_digitClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~write_digitClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<MIO *>(dev))->is_write_digit_allowed(any);}
};



//
// The MIOClass singleton definition
//

class
#ifdef _TG_WINDOWS_
	__declspec(dllexport)
#endif
	MIOClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static MIOClass *init(const char *);
	static MIOClass *instance();
	~MIOClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	MIOClass(string &);
	static MIOClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace MIO_ns

#endif // _MIOCLASS_H
